# coding: utf-8

import unohelper

from com.sun.star.task import XJob
from com.sun.star.ui import XContextMenuInterceptor


class DocContextMenuHandler(XContextMenuInterceptor, unohelper.Base):
	def __init__(self, ctx):
		self.ctx = ctx
	def notifyContextMenuExecute(self, ev):
		print("notify.")


class JobExecutor(XJob, unohelper.Base):
	def __init__(self, ctx):
		#print("initiated.")
		self.ctx = ctx
	def execute(self, args):
		if not args: return
		correctEvent = False
		for arg in args:
			if arg.Name == "Environment":
				value = arg.Value
				for v in value:
					if v.Name == "EnvType" and v.Value == "DOCUMENTEVENT":
						correctEvent = True
					elif v.Name == "EventName":
						pass # check is correct event
						#print("Event: %s" % v.Value)
					elif v.Name == "Model":
						model = v.Value
		if correctEvent:
			if model.supportsService("com.sun.star.text.TextDocument"):
				controller = model.getCurrentController()
				if controller:
					controller.registerContextMenuInterceptor(DocContextMenuHandler(self.ctx))
					#print("registered.")


g_ImplementationHelper = unohelper.ImplementationHelper()
g_ImplementationHelper.addImplementation(
	JobExecutor,
	"mytools.ContextMenuHandler", ("mytools.ContextMenuHandler",),)

